let shell = require('shell');
let $ = require('jquery');

let Constant = require('../modules/Constant');
let Core = require('../modules/Core');

let webview = document.querySelector('webview');
let $loading = $('.loading-overlay');
let isWebviewLoaded = false;

$(window).on('online offline', function() {
  let isOnline = navigator.onLine;

  if (isWebviewLoaded) {
    // good, we don't need to do anything because we did handle that
    // in our client.
  } else {
    // Otherwise, we need to reload the webview when we are back to
    // online again.
    if (isOnline) {
      webview.reload();
    }
  }
});

$(window).on('wheel', function(e) {
  // [HACK]
  //
  // we need to have a wheel event hooked here to make the pinch event can
  // be detected in webview. weird
});

// if we try to create a new window, if it's still under vectr (or isDev()),
// we will directly redirect users to there, otherwise, we will show the link
// on default browser.
webview.addEventListener('new-window', function(e) {
  if (e.url.match(/vectr.com/) || Core.isDev()) {
    webview.src = e.url;
  } else {
    shell.openExternal(e.url);
  }
});

webview.addEventListener('page-title-set', function(e) {
  Core.emit('title-updated', e.title);
});

webview.addEventListener('did-get-response-details', function() {
  isWebviewLoaded = true;
  $loading.addClass('hide');
});

webview.addEventListener('did-fail-load', function() {
  $loading.find('.hint').text('No connection,' +
    ' we will try to re-connect automatically when network is back.');
});

// Set webview src based on current environment
webview.src = Constant.WEBVIEW_URL;
